/* makez80rle - use .Z80-style RLE compression on 42240 byte .bin file
 *   on stdin, with compressed output on stdout.
 * (originally for nc100 speccy hacks)
 * based on:
 */

/* rawtoz80 - makes 128k Z80 given suitable raw v2/v3 header and page data.
 * originally written for use by bigv3-make, but may be useful more generally.
 * Z80 generating code nicked from my 128k xz80 hack.
 *
 * PD by RJM
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>


unsigned char mem[6912];



/* based on code from my 128k xz80 hack */
void z80save128(void)
{
static unsigned char outbuf[6912];
int tmp;
int count=0;
unsigned char *src=mem,*dst=outbuf;
int old=-1,c,f,g,run=0;
      
/* we do the compression into outbuf before writing anything
 * to the file.
 */
for(f=0;f<=6912;f++)
  {
  if(f==6912) c=-1; else c=*src++;
  if(old==c)
    run++;
  else
    {
    if(run>1)
      {
      if(run>=5 || old==0xed)
        {
        if(dst>outbuf && dst[-1]==0xed)
          {
          *dst++=old;
          run--;
          }
        while(run>0)
          {
          g=((run>255)?255:run);
          *dst++=0xed; *dst++=0xed;
          *dst++=g;    *dst++=old;
          run-=g;
          }
        }
      else
        for(g=0;g<run;g++) *dst++=old;
      }
    else
      if(old!=-1) *dst++=old;
    run=1;
    }
  old=c;
  }

/* and actually write the compressed data */
count=dst-outbuf;
fputc(count%256,stdout);
fputc(count/256,stdout);
fwrite(outbuf,1,count,stdout);
}


int main(void)
{
char outfile[256];
int expect,tmp,p;
int pc,sp,sevenffd;
int f;

fread(mem,1,6912,stdin);

/* write Z80-ish file */
z80save128();

exit(0);
}
